function recursiveClean(obj) {
    if (obj === null) {
        return null;
    }

    switch (obj.__proto__.constructor.name) {
        case 'Object':
            return handleObject(obj);
        case 'Array':
            return handleArray(obj);
        default:
            return obj;
    }
}

function handleArray(arr) {
    const array = [];
    for (let index = 0; index < arr.length; index++) {
        if (arr[index] !== undefined) {
            const value = recursiveClean(arr[index]);
            if (value !== undefined) {
                array.push(value);
            }
        }
    }
    return array;
}

function handleObject(obj) {
    const result = {};
    for (let key in obj) {
        if (obj[key] !== undefined) {
            const value = recursiveClean(obj[key]);
            if (value !== undefined) {
                result[key] = value;
            }
        }
    }
    if (length(result) === 0) {
        return undefined;
    }
    return result;
}

function length(obj) {
    const keys = Object.keys(obj);
    return keys.length;
}

module.exports = recursiveClean;
